﻿<?php
/*
Plugin Name: BanglaDate
Plugin URI: http://www.ekushey.org
Description: Convert English Dates to Bangla Dates.
Version: 1.0
Author: Hasin Hayder
Author URI: http://www.hasinhayder.net
*/

add_filter('the_time', 'bangladate');
add_filter('the_date', 'bangladate');
add_filter('get_comment_date', 'bangladate');
add_filter('get_comment_time', 'bangladate');

$lang['cal_jan'] 		= "জানুয়ারী";
$lang['cal_feb'] 		= "ফেব্রুয়ারী";
$lang['cal_mar'] 		= "মার্চ";
$lang['cal_apr'] 		= "এপ্রিল";
$lang['cal_may'] 		= "মে";
$lang['cal_jun'] 		= "জুন";
$lang['cal_jul'] 		= "জুলাই";
$lang['cal_aug'] 		= "অগাস্ট";
$lang['cal_sep'] 		= "সেপ্টেম্বর";
$lang['cal_oct'] 		= "অক্টোবর";
$lang['cal_nov'] 		= "নভেম্বর";
$lang['cal_dec'] 		= "ডিসেম্বর";
$lang['cal_january'] 	= "জানুয়ারী";
$lang['cal_february'] 	= "ফেব্রুয়ারী";
$lang['cal_march'] 		= "মার্চ";
$lang['cal_april']		= "এপ্রিল";
$lang['cal_june'] 		= "জুন";
$lang['cal_july'] 		= "জুলাই";
$lang['cal_august']		= "অগাস্ট";
$lang['cal_september']	= "সেপ্টেম্বর";
$lang['cal_october'] 	= "অক্টোবর";
$lang['cal_november']	= "নভেম্বর";
$lang['cal_december'] 	= "ডিসেম্বর";

function bangladate($content) {
    /**
    * @desc : convert english dates into unicode formatted bangla dates                      
    * @author : Hasin Hayder
    * @since : June 15, 2007
    */
     global $lang;
     $content = strtolower($content);
     for ($i=1; $i<12; $i++)
     {
     	$month = strtolower(Date("F",strtotime("{$i}/10/2007")));
     	$content = str_replace($month, $lang["cal_{$month}"],$content);
     }
     
     for ($i=1; $i<12; $i++)
     {
     	$month = strtolower(Date("M",strtotime("{$i}/10/2007")));
     	$content = str_replace($month, $lang["cal_{$month}"],$content);
     }
     
     $content = str_replace("th","",$content);
     $content = str_replace("am","পূর্বাহ্ন",$content);
     $content = str_replace("pm","অপরাহ্ন",$content);
     return number2unicode($content);
}

function number2unicode($content)
	{
	    /**       
         * @desc : convert english digits to bangla digits
	     * @author : Hasin Hayder
	     * @since : Feb 23, 2007
	     */
		$d='';
		$numbers = array(
		48=>"&#2534;",
		49=>"&#2535;",
		50=>"&#2536;",
		51=>"&#2537;",
		52=>"&#2538;",
		53=>"&#2539;",
		54=>"&#2540;",
		55=>"&#2541;",
		56=>"&#2542;",
		57=>"&#2543;",
		);
		for ($i=0; $i<strlen($content); $i++)
		{
			$current = ord(substr($content,$i,1));
			if (array_key_exists($current,$numbers) )
			$unicode = $numbers[$current];
			else
			$unicode = chr($current);
			$d .= $unicode;
		}
		return "".$d."";

	}
?>